"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactShape = void 0;
var x6_1 = require("@antv/x6");
var ReactShape = /** @class */ (function (_super) {
    __extends(ReactShape, _super);
    function ReactShape() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ReactShape.prototype, "component", {
        get: function () {
            return this.getComponent();
        },
        set: function (val) {
            this.setComponent(val);
        },
        enumerable: false,
        configurable: true
    });
    ReactShape.prototype.getComponent = function () {
        return this.store.get('component');
    };
    ReactShape.prototype.setComponent = function (component, options) {
        if (options === void 0) { options = {}; }
        if (component == null) {
            this.removeComponent(options);
        }
        else {
            this.store.set('component', component, options);
        }
        return this;
    };
    ReactShape.prototype.removeComponent = function (options) {
        if (options === void 0) { options = {}; }
        this.store.remove('component', options);
        return this;
    };
    return ReactShape;
}(x6_1.Node));
exports.ReactShape = ReactShape;
(function (ReactShape) {
    ReactShape.config({
        view: 'react-shape-view',
        markup: [
            {
                tagName: 'rect',
                selector: 'body',
            },
            __assign({}, x6_1.Markup.getForeignObjectMarkup()),
            {
                tagName: 'text',
                selector: 'label',
            },
        ],
        attrs: {
            body: {
                fill: 'none',
                stroke: 'none',
                refWidth: '100%',
                refHeight: '100%',
            },
            fo: {
                refWidth: '100%',
                refHeight: '100%',
            },
            label: {
                fontSize: 14,
                fill: '#333',
                refX: '50%',
                refY: '50%',
                textAnchor: 'middle',
                textVerticalAnchor: 'middle',
            },
        },
    });
    x6_1.Node.registry.register('react-shape', ReactShape, true);
})(ReactShape = exports.ReactShape || (exports.ReactShape = {}));
exports.ReactShape = ReactShape;
//# sourceMappingURL=node.js.map